﻿using System;
using System.IO;
using System.Reflection;

namespace UseImportData
{
    class Program
    {
        static void Main(string[] args)
        {
            Old_CroosBookFormula();
            New_CroosBookFormula();
            Console.ReadKey();
        }

        static void Old_CroosBookFormula()
        {
            //create a new workbook
            var workbook = new GrapeCity.Documents.Excel.Workbook();

            //Start time to read Excel data
            DateTime startTime = DateTime.Now;

            //Import Excel data using Open Method
            workbook.Open(GetResourceStream("xlsx\\Urban Centers 2017.xlsx"));
            var flints = new GrapeCity.Documents.Excel.Workbook();
            flints.Open(GetResourceStream("xlsx\\Flints.xlsx"));
            var jackson = new GrapeCity.Documents.Excel.Workbook();
            jackson.Open(GetResourceStream("xlsx\\Jackson.xlsx"));
            var petrosky = new GrapeCity.Documents.Excel.Workbook();
            petrosky.Open(GetResourceStream("xlsx\\Petrosky.xlsx"));

            //End time to read Excel data
            DateTime endTime = DateTime.Now;
            //Total time consumed to read data
            TimeSpan timeConsumed = endTime - startTime;
            Console.WriteLine("Data Imported, time consumed by Open method to load data: " + timeConsumed.Milliseconds.ToString() +"ms");

            //Apply formulas
            workbook.Worksheets[0].Range["B6:E11"].Formula = "='[Flints.xlsx]Sheet1'!B7+'[Jackson.xlsx]Sheet1'!B6+'[Petrosky.xlsx]Sheet1'!B7";
            workbook.UpdateExcelLink("Flints.xlsx", flints);
            workbook.UpdateExcelLink("Jackson.xlsx", jackson);
            workbook.UpdateExcelLink("Petrosky.xlsx", petrosky);
            workbook.Calculate();

            //save to an excel file
            workbook.Save("crossworkbookformula1.xlsx");
            Console.WriteLine("Workbook saved !!!");
        }

        static void New_CroosBookFormula()
        {           
            //Start time to read Excel data
            DateTime startTime = DateTime.Now;

            //create a new workbook         
            var workbook = new GrapeCity.Documents.Excel.Workbook();
            //Import Excel data using ImportData Method
            var fileStream = GetResourceStream("xlsx\\Urban Centers 2017.xlsx");
            //Import data of a sheet from the fileStream
            var data = GrapeCity.Documents.Excel.Workbook.ImportData(fileStream, "Sheet1");
            //Assign the data to new worksheet
            workbook.Worksheets[0].Range["A1:F12"].Value = data;

            var flints = new GrapeCity.Documents.Excel.Workbook();
            fileStream = GetResourceStream("xlsx\\Flints.xlsx");
            data = GrapeCity.Documents.Excel.Workbook.ImportData(fileStream, "Sheet1");
            flints.Worksheets[0].Range["A1:F13"].Value = data;

            var jackson = new GrapeCity.Documents.Excel.Workbook();
            fileStream = GetResourceStream("xlsx\\Jackson.xlsx");
            data = GrapeCity.Documents.Excel.Workbook.ImportData(fileStream, "Sheet1");
            jackson.Worksheets[0].Range["A1:F12"].Value = data;

            var petrosky = new GrapeCity.Documents.Excel.Workbook();
            fileStream = GetResourceStream("xlsx\\Petrosky.xlsx");
            data = GrapeCity.Documents.Excel.Workbook.ImportData(fileStream, "Sheet1");
            petrosky.Worksheets[0].Range["A1:F13"].Value = data;

            //End time to read Excel data
            DateTime endTime = DateTime.Now;
            //Total time consumed to read data
            TimeSpan timeConsumed = endTime - startTime;
            Console.WriteLine("Data Imported, time consumed by ImportData method to load data: " + timeConsumed.Milliseconds.ToString() + "ms");

            //Apply formulas
            workbook.Worksheets[0].Range["B6:E11"].Formula = "='[Flints.xlsx]Sheet1'!B7+'[Jackson.xlsx]Sheet1'!B6+'[Petrosky.xlsx]Sheet1'!B7";
            workbook.UpdateExcelLink("Flints.xlsx", flints);
            workbook.UpdateExcelLink("Jackson.xlsx", jackson);
            workbook.UpdateExcelLink("Petrosky.xlsx", petrosky);            
            workbook.Worksheets[0].Range["B12:E12"].Formula = "=SUM(B6:B11)";
            workbook.Worksheets[0].Range["F6:F12"].Formula = "=SUM(B6:E6)";
            workbook.Calculate();

            //save to an excel file
            workbook.Save("crossworkbookformula2.xlsx");
            Console.WriteLine("Workbook saved !!!");
        }

        static Stream GetResourceStream(string resourcePath)
        {
            string resource = "UseImportData.Resource." + resourcePath.Replace("\\", ".");
            var assembly = typeof(Program).GetTypeInfo().Assembly;
            return assembly.GetManifestResourceStream(resource);
        }
    }
}
